> For the complete documentation index, see [llms.txt](https://docs.bindplane.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bindplane.com/deployment/kubernetes/collector/custom-service.md).

# Custom Service

A Kubernetes Service can be used to route network traffic to your Bindplane collectors.

When adding sources such as [Syslog](/integrations/sources/syslog.md), [TCP](/integrations/sources/tcp.md), [UDP](/integrations/sources/udp.md), you must create a custom [Kubernetes Service](https://kubernetes.io/docs/concepts/services-networking/service/) to route the traffic.

### **Bindplane Node**

This example shows how to expose TCP port `5140`, routing to the Bindplane Node collector.

```yaml
apiVersion: v1
kind: Service
metadata:
  name: bindplane-node-agent-syslog
  namespace: bindplane-agent
  labels:
    app.kubernetes.io/component: gateway
    app.kubernetes.io/name: bindplane-agent
spec:
  ports:
    - appProtocol: tcp
      name: syslog-tcp
      port: 5140
      protocol: TCP
      targetPort: 5140
  selector:
    app.kubernetes.io/component: node
    app.kubernetes.io/name: bindplane-agent
  type: ClusterIP
```

### **Bindplane Gateway**

This example shows how to expose TCP port `5140`, routing to the Bindplane Gateway collector.

```yaml
apiVersion: v1
kind: Service
metadata:
  name: bindplane-gateway-agent-syslog
  namespace: bindplane-agent
  labels:
    app.kubernetes.io/component: gateway
    app.kubernetes.io/name: bindplane-agent
spec:
  ports:
    - appProtocol: tcp
      name: syslog-tcp
      port: 5140
      protocol: TCP
      targetPort: 5140
  selector:
    app.kubernetes.io/component: gateway
    app.kubernetes.io/name: bindplane-agent
  type: ClusterIP
```

### Ingress

If you want to route traffic external to your cluster, you can use an Ingress resource to route traffic to the custom service.

You can read more about Ingress [here](https://kubernetes.io/docs/concepts/services-networking/ingress/).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.bindplane.com/deployment/kubernetes/collector/custom-service.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
